package communicationservices;

import dataservices.*;
import controlservices.*;

import java.io.*;
import java.net.*;

/**
 * <p>Title: </p>
 * <p>Description: Inits POMESClients and notifies ProxyManager of recieved XML</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Printronix</p>
 * @author Christopher M. King (kingc@uci.edu)
 * @version 1.0
 */

public class POMESComManager
       implements ProxyConstants
{
  // Load some defaults
  private static String pomesIP   = POMES_IP;
  private static int pomesPort    = POMES_PORT;
  private static String name      = NAME;
  private static String password  = PASSWORD;

  private ProxyManager proxyManager;

  public POMESComManager(ProxyManager pM)
  {
    proxyManager = pM;
  }

  public POMESComManager(ProxyManager pM, String ip, int port)
  {
    proxyManager = pM;
    pomesIP = ip;
    pomesPort = port;
  }

  public POMESComManager(ProxyManager pM, String ip, int port, String newName, String newPassword)
  {
    proxyManager = pM;
    pomesIP = ip;
    pomesPort = port;
    name = newName;
    password = newPassword;
  }

  public POMESClient createPOMESClient()
  {
    return new POMESClient(this, pomesIP, pomesPort, name, password);
  }

  public void recievedXML(String xml)
  {
    proxyManager.recievedXML(xml);
  }
}
