package communicationservices;

import controlservices.*;
import dataservices.*;

import java.io.*;
import java.net.*;
import java.util.*;

/**
 * <p>Title: UDPComManager</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Printronix</p>
 * @author Allen Liao (ailiao@uci.edu)
 * @version 1.2
 */

public class UDPComManager
    implements ProxyConstants
{
  private ProxyManager proxyManager;

  private int port = LISTEN_PORT;

  public UDPComManager(ProxyManager pM)
  {
    proxyManager = pM;
  }

  public UDPComManager(ProxyManager pM, int p)
  {
    proxyManager = pM;
    port = p;
  }

  public void listen()
  {
    UDPListener udpListener = new UDPListener(port, this);
    udpListener.start();
  }

  public void listen(int p)
  {
    UDPListener udpListener = new UDPListener(p, this);
    udpListener.start();
  }

  public void send(DatagramPacket udp)
  {
    try
    {
      DatagramSocket sock = null;
      sock = new DatagramSocket();
      UDPSender udpSender = new UDPSender(sock);
      udpSender.send(udp);
    }
    catch(SocketException e)
    {
      System.out.println("Error: " + e.toString());
    }
  }
  public void recievedUDP(DatagramPacket udpPacket)
  {
    proxyManager.recievedUDP(udpPacket);
  }
}

