package communicationservices;

import java.io.*;
import java.net.*;
import java.util.*;

/**
 * <p>Title: UDPListener</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Printronix</p>
 * @author Christopher M. King
 * @version 1.2
 */

public class UDPListener extends Thread
{
  private static final int MAX_PACKET_SIZE = 65000;

  private DatagramPacket udpPacket;
  private DatagramSocket socket;

  byte[] buf;
  int port;

  UDPComManager udpComManager;

  public UDPListener(int port, UDPComManager uCM)
  {
    try
    {
      udpComManager=uCM;
      socket = new DatagramSocket(port);
    }
    catch(SocketException e) // Override of run forces exception catch here
    {
      System.out.println(e.toString());
      System.exit(1);       // No point in going further
    }
  }

  public void run()
  {
    try
    {
      while(true)
      {
        buf = new byte[MAX_PACKET_SIZE];
        udpPacket = new DatagramPacket(buf, MAX_PACKET_SIZE);
        socket.receive(udpPacket);
        udpComManager.recievedUDP(udpPacket);
      }
    }
    catch(IOException e) // Override of run forces exception catch here
    {
      System.out.println(e.toString());
    }
  }
}


