package dataservices;

import java.io.*;
import java.util.StringTokenizer;

// loads settings from cfg file
public class ProxyConfig
       implements ProxyConstants
{
    public static final String ARG_ERROR = "USAGE: [/? | /ip [POMES IP] "
                                         + "| / port [POMES port] "
                                         + "| /listen [port] "
                                         + "| /config [file name] "
                                         + "| /debug] ";

    private String community       = COMMUNITY;
    private String translationFile = TRANSLATION_FILE;
    private String logFile         = LOG_FILE;
    private String configFile      = CONFIG_FILE;
    private String pomesIP         = POMES_IP;
    private int    pomesPort       = POMES_PORT;
    private int    resposneTimeout = RESPONSE_TIMEOUT;
    private int    listenPort      = LISTEN_PORT;
    private String name            = NAME;
    private String password        = PASSWORD;
    private int sessionTimeout     = SESSION_TIMEOUT;
    private boolean debug          = DEBUG;

    public String getCommunity()        { return community;       }
    public String getTranslationFile()  { return translationFile; }
    public String getLogFileName()      { return logFile;         }
    public String getPomesIP()          { return pomesIP;         }
    public int getPomesPort()           { return pomesPort;       }
    public int getSessionTimeout()      { return sessionTimeout;  }
    public int getResponseTimeout()     { return resposneTimeout; }
    public int getListenPort()          { return listenPort;      }
    public String getName()             { return name;            }
    public String getPassword()         { return password;        }
    public String getConfigFileName()   { return configFile;      }
    public boolean getDebug()           { return debug;           }

    public void ProxyConfig()
    {
    }

    public void ProxyConfig(String [] args, String fileName)
    {
       this.loadArguments(args);
       this.loadConfigFile(fileName);
    }

   // WARNING: Will shutdown program upon error (by design)
   public void loadArguments(String [] args)
   {
     // Mostly unimplemented due since all functionality of this func
     // is replicated by the loadConfigFile() and was un-needed.

     // TO DO: Better checks here
     if(args.length != 1)
     {
        System.out.println(ARG_ERROR);
        System.exit(1);
     }
     return;
   }

    public void loadConfigFile(String fileName)
    {
      if( isPresent(fileName) )
      {
        try
        {
          BufferedReader in
          = new BufferedReader( new FileReader(fileName) );

          String s;
          StringTokenizer t;
          String temp;

          while( ( s = in.readLine() ) != null )
          {
            t = new StringTokenizer( s, "=" );

            if( t.hasMoreTokens() && t.countTokens() == 2 )
            {
              temp = t.nextToken();

              if( temp.equals( "community" ) )
                community = t.nextToken().trim();

              else if( temp.equals( "translationFile" ) )
                translationFile = t.nextToken().trim();

              else if( temp.equals( "logFile" ) )
                logFile = t.nextToken().trim();

              else if( temp.equals( "pomesIP" ) )
                pomesIP = t.nextToken().trim();

              else if( temp.equals("listenPort") )
                listenPort = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("pomesPort") )
                pomesPort = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("sesionTimeout") )
                sessionTimeout = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("responseTimeout") )
                resposneTimeout = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("listenPort") )
                listenPort = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("name") )
                name = t.nextToken().trim();

              else if( temp.equals("debug") )
              { String dB = t.nextToken().trim();
                if(dB.toLowerCase().equals("true"))
                  debug = true;
              }

              else if( temp.equals("password") )
                password = t.nextToken().trim();
            }
          }
        }
        catch( IOException e )
        {
          System.out.println(e.toString());
        }
      }
      else
      {
         System.out.println(CONFIG_ERROR);
      }
    }

    private boolean isPresent( String file )
    {
        File config = new File(file);
        return config.exists();
    }

    public String toString()
    {
        String temp = "";
        temp += "community = " + community;
        temp += "translationFile = " + translationFile;
        temp += "logFile = " + logFile;
        temp += "pomesIP = " + pomesIP;
        temp += "pomesPort = " + pomesPort;
        temp += "sessionTimeout = " + sessionTimeout;
        temp += "listenPort = " + listenPort;
        return temp;
    }
}