package dataservices;
import java.util.*;
import java.io.*;

/**
 * <p>Title: Log</p>
 * <p>Description: Gives basic log to file capabilities</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Printronix</p>
 * @author Allen Liao (ailiao@uci.edu)
 * @version 1.0
 */

public class ProxyLog
    implements ProxyConstants
{
    private BufferedWriter out;
    private File file;

    public ProxyLog()
    {
        file = new File(LOG_FILE);  // load default
        createFile();
    }

    public ProxyLog(String fileName)
    {
        file = new File(fileName);
        createFile();
    }

    public synchronized void logEvent(String log)
    {
        try
        {
            out = new BufferedWriter(new FileWriter(file.getPath(), true));
            out.write(log + "\n");
            out.close();
        }
        catch(IOException e)
        {
            System.out.println("Error: could not write file writing the file " + e);
        }
    }

    //creates a new log file, deleting any previously created logs
    private void createFile()
    {
        if(file.exists())
            file.delete();
        try
        {
            file.createNewFile();
        }
        catch(IOException e)
        {
             System.out.println("Error creating the file " + e);
        }
    }
}