package dataservices;

import snmp.*;
import java.util.*;
import communicationservices.*;

// Used to check SNMP messages against the stored community name
public class ProxySecurityManager
    implements ProxyConstants
{
  private String communityName;
  private String securityToken;

  public ProxySecurityManager(String newCommunity, String newToken)
  {
    this.setCommunityName(newCommunity);  // set to default
    this.setPOMESSecurityToken(newToken); // set to default
  }

  public ProxySecurityManager()
  {
    this.setCommunityName(COMMUNITY);  // set to default
    this.setPOMESSecurityToken(TOKEN); // set to default
  }

  public void setCommunityName(String name)
  {
     communityName = name;
  }
  public String getCommunityName()
  {
    return communityName;
  }

  public void setPOMESSecurityToken(String name)
  {
    securityToken = name;
  }

  public String getPOMESSecurityToken()
  {
    return securityToken;
  }

  public boolean verifyCommunityName(SNMPOctetString name)
  {
    return communityName.equals(name.toString());
  }
}