package dataservices;

import controlservices.*;

/**
 * <p>Title: SNMPTimer</p>
 * <p>Description: Used by the ProtocolHandler to handle timeout preventsion</p>
 * @see ProtocolThread
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Raymundo Anaya (anayar@uci.edu)
 * @version 1.0
 */

public class ProxyTimer implements Runnable
{
    private Thread timer;
    private int interval;        //every 1000 is a second
    public boolean expired;      //check to see if timer has expired
    public boolean sendWait;     //check to see if wait message should be sent
    private boolean stopped;
    private ProtocolHandler protocolHandler;

    public ProxyTimer(int i, ProtocolHandler pH)
    {
        interval = i;
        expired = false;

        protocolHandler = pH;
    }

    public boolean isExpired()
    {
        return expired;
    }

    public void start()
    {
        timer = new Thread(this);
        stopped = false;
        timer.start();
    }
    public void stop()
    {
        timer = null;
        stopped = true;
    }

    public void run()
    {
        while (timer!=null)
        {
            try
            {
              Thread.sleep(interval);
            }
            catch (InterruptedException e){}

            if(!stopped)// hasn't been stopped by outside function
            {
              protocolHandler.timeoutHandler();
            }
            stop();
            expired = true;
        }
    }
}

