package dataservices;

import java.util.*;

// Represents an entry in the translations table
public class TranslationTableEntry extends MibOidEntry
{
	String profileValue;
	String command;
	String attributeList;

	public TranslationTableEntry ()
	{
		super();
		profileValue = null;
		command = null;
		attributeList = null;
	}

	public TranslationTableEntry (String oid, String access, String type, String value,
				String command,	String attributeList)
	{
		super(oid, access, type);
		this.profileValue = value;
		this.command = command;
		this.attributeList = attributeList;
	}
	public String getProfileValue ()
	{
		return profileValue;
	}

	public String getCommand ()
	{
		return command;
	}

	public String getAttributeList ()
	{
		return attributeList;
	}

        public Vector getAttributes()
        {
           StringTokenizer st = new StringTokenizer(attributeList, ",");

           Vector attrs = new Vector();
           while(st.hasMoreTokens())
           {
               attrs.add(st.nextToken());
           }
           return attrs;
        }
}